package gregapi.data;

import static gregapi.data.CS.C;
import static gregapi.data.CS.F;
import static gregapi.data.CS.FluidsGT.*;
import gregapi.data.CS.FluidsGT;
import gregapi.item.multiitem.food.FoodStatDrink;
import gregapi.util.UT;

import java.util.Collection;

import net.minecraft.item.EnumAction;
import net.minecraft.potion.Potion;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidTank;

/**
 * @author Gregorius Techneticies
 * 
 * Class containing all known Fluid Names
 */
public enum FL {
	  Error						("error")
	  
	, Air						("air"														, SIMPLE, GAS)
	
	, Steam						("steam"													, SIMPLE, GAS, STEAM)
	, Steam_IC2					("ic2steam"													, SIMPLE, GAS, STEAM)
	, Steam_IC2_Superheated		("ic2superheatedsteam"										, SIMPLE, GAS, STEAM)
	
	, Lava						("lava"														, SIMPLE, LIQUID)
	
	, Water						("water"													, SIMPLE, LIQUID, FOOD, WATER)
	, DistW						("ic2distilledwater"										, SIMPLE, LIQUID, FOOD, WATER)
	, Ice						("ice"														, SIMPLE, LIQUID, FOOD, WATER, THERMOS)
	, Ocean						("seawater"													, SIMPLE, LIQUID)
	, Saltwater					("saltwater"												, SIMPLE, LIQUID)
	
	, Milk						("milk"														, SIMPLE, LIQUID, FOOD, MILK)
	, SoyM						("soymilk"					, "potion.soymilk"				, SIMPLE, LIQUID, FOOD, MILK)
	
	, Honey						("for.honey"				, "honey"						, SIMPLE, LIQUID, FOOD, HONEY)
	, Honeydew					("for.honeydew"				, "honeydew"					, SIMPLE, LIQUID, FOOD, ALCOHOLIC)
	
	, Lubricant					("lubricant"												, SIMPLE, LIQUID, LUBRICANT)
	, LubRoCant					("rc lubricant"												, SIMPLE, LIQUID, LUBRICANT)
	
	, Juice						("juice"													, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Melon				("melonjuice"												, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Kiwi				("kiwijuice"												, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Currant				("currantjuice"												, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Raspberry			("raspberryjuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Blackberry			("blackberryjuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Blueberry			("blueberryjuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Gooseberry			("gooseberryjuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Strawberry			("strawberryjuice"			, "potion.strawberryjuice"		, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Plum				("binnie.juiceplum"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Peach				("binnie.juicepeach"										, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Elderberry			("binnie.juiceelderberry"									, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Grapefruit			("binnie.juicegrapefruit"									, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Lime				("binnie.juicelime"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Orange				("binnie.juiceorange"										, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Apricot				("binnie.juiceapricot"										, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Pear				("binnie.juicepear"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Grape_Red			("binnie.juiceredgrape"										, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Grape_White			("binnie.juicewhitegrape"	, "potion.grapejuice"			, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Apple				("binnie.juiceapple"		, "potion.applejuice"			, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Ananas				("binnie.juicepineapple"	, "pineapplejuice"				, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Banana				("binnie.juicebanana"		, "potion.bananajuice"			, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Cherry				("binnie.juicecherry"		, "cherryjuice"					, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Cranberry			("binnie.juicecranberry"	, "cranberryjuice"				, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Lemon				("binnie.juicelemon"		, "potion.lemonjuice"			, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_CactusFruit			("cactusfruitjuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Mango				("mangojuice"												, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Pomegranate			("pomegranatejuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Starfruit			("starfruitjuice"											, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Date				("datejuice"												, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	, Juice_Papaya				("papayajuice"												, SIMPLE, LIQUID, FOOD, JUICE, FRUIT_JUICE)
	
	, Smoothie_Fruit			("fruitsmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Melon			("melonsmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Kiwi				("kiwismoothie"												, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Currant			("currantsmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Raspberry		("raspberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Blackberry		("blackberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Blueberry		("blueberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Gooseberry		("gooseberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Strawberry		("strawberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Plum				("plumsmoothie"												, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Peach			("peachsmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Elderberry		("elderberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Grapefruit		("grapefruitsmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Lime				("limesmoothie"												, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Orange			("orangesmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Apricot			("apricotsmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Pear				("pearsmoothie"												, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Grape_Red		("redgrapesmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Grape_White		("whitegrapesmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Apple			("applesmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Ananas			("pineapplesmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Banana			("bananasmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Cherry			("cherrysmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Cranberry		("cranberrysmoothie"										, SIMPLE, LIQUID, FOOD, THERMOS)
	, Smoothie_Lemon			("lemonsmoothie"											, SIMPLE, LIQUID, FOOD, THERMOS)
	
	, Juice_Carrot				("binnie.juicecarrot"		, "carrotjuice"					, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Tomato				("binnie.juicetomato"		, "tomatojuice"					, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Beet				("beetjuice"												, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Cucumber			("cucumberjuice"											, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Onion				("onionjuice"												, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Potato				("potatojuice"				, "potion.potatojuice"			, SIMPLE, LIQUID, FOOD, JUICE)
	, Juice_Reed				("reedwater"				, "potion.reedwater"			, SIMPLE, LIQUID, FOOD, JUICE)
	
	, Mash_Rice					("ricewater"				, "potion.ricewater"			, SIMPLE, LIQUID, FOOD)
	, Mash_Hops					("hopsmash"					, "potion.hopsjuice"			, SIMPLE, LIQUID, FOOD)
	, Mash_WheatHops			("wheathopsmash"			, "potion.wheatyhopsjuice"		, SIMPLE, LIQUID, FOOD)
	, Mash_Wheat				("binnie.mashwheat"			, "potion.wheatyjuice"			, SIMPLE, LIQUID, FOOD)
	, Mash_Corn					("binnie.mashcorn"											, SIMPLE, LIQUID, FOOD)
	, Mash_Rye					("binnie.mashrye"											, SIMPLE, LIQUID, FOOD)
	, Mash_Grain				("binnie.mashgrain"											, SIMPLE, LIQUID, FOOD)
	
	, Slime_Pink				("pinkslime"												, SIMPLE, LIQUID, FOOD)
	
	, Tea						("tea"						, "potion.tea"					, SIMPLE, LIQUID, FOOD, THERMOS, TEA)
	, Tea_Sweet					("sweettea"					, "potion.sweettea"				, SIMPLE, LIQUID, FOOD, THERMOS, TEA)
	, Tea_Ice					("icetea"					, "potion.icetea"				, SIMPLE, LIQUID, FOOD, THERMOS, TEA)
	
	, Vinegar_Grape				("vinegar"					, "potion.vinegar"				, SIMPLE, LIQUID, FOOD, ALCOHOLIC, VINEGAR)
	, Vinegar_Apple				("applevinegar"												, SIMPLE, LIQUID, FOOD, ALCOHOLIC, VINEGAR)
	, Vinegar_Cane				("canevinegar"												, SIMPLE, LIQUID, FOOD, ALCOHOLIC, VINEGAR)
	, Vinegar_Rice				("ricevinegar"												, SIMPLE, LIQUID, FOOD, ALCOHOLIC, VINEGAR)
	
	, Wine_Grape_Red			("binnie.winered"			, "potion.wine", "wine"			, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WINE)
	, Wine_Grape_White			("binnie.winewhite"											, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WINE)
	, Whiskey					("binnie.whiskey"			, "whiskey"						, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WHISKEY)
	, Whiskey_Rye				("binnie.whiskeyrye"										, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WHISKEY)
	, Whiskey_Corn				("binnie.whiskeycorn"										, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WHISKEY)
	, Whiskey_Scotch			("binnie.whiskeywheat"		, "potion.scotch"				, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WHISKEY)
	, Whiskey_GlenMcKenner		("glenmckenner"				, "potion.glenmckenner"			, SIMPLE, LIQUID, FOOD, ALCOHOLIC, WHISKEY)
	, Cider_Apple				("binnie.ciderapple"		, "potion.cider", "cider"		, SIMPLE, LIQUID, FOOD, ALCOHOLIC, CIDER)
	, Cider_Pear				("binnie.ciderpear"											, SIMPLE, LIQUID, FOOD, ALCOHOLIC, CIDER)
	, Cider_Peach				("binnie.ciderpeach"										, SIMPLE, LIQUID, FOOD, ALCOHOLIC, CIDER)
	, Rum_White					("binnie.rumwhite"			, "potion.rum", "rum"			, SIMPLE, LIQUID, FOOD, ALCOHOLIC, RUM)
	, Rum_Dark					("binnie.rumdark"			, "potion.piratebrew"			, SIMPLE, LIQUID, FOOD, ALCOHOLIC, RUM)
	, Vodka						("binnie.vodka"				, "potion.vodka", "vodka"		, SIMPLE, LIQUID, FOOD, ALCOHOLIC)
	, Mead						("short.mead"				, "mead"						, SIMPLE, LIQUID, FOOD, ALCOHOLIC)
	
	, Oil_Sunflower				("sunfloweroil"												, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Olive					("binnie.juiceolive"		, "oliveoil"					, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Nut					("nutoil"													, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Lin					("linoil"					, "linseedoil"					, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Hemp					("hempoil"					, "hempseedoil"					, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Seed					("seedoil"													, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Fish					("fishoil"													, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Frying				("hotfryingoil"												, SIMPLE, LIQUID, FOOD, COOKING_OIL)
	, Oil_Plant					("plantoil"													, SIMPLE, LIQUID)
	, Oil_Creosote				("creosote"													, SIMPLE, LIQUID)
	, Oil_Soulsand				("soulsandoil"												, SIMPLE, LIQUID)
	, Oil_Normal				("oil"														, SIMPLE, LIQUID)
	, Oil_Fuel					("fuel"														, SIMPLE, LIQUID)
	, Oil_Light					("liquid_light_oil"											, SIMPLE, LIQUID)
	, Oil_Medium				("liquid_medium_oil"										, SIMPLE, LIQUID)
	, Oil_Heavy					("liquid_heavy_oil"											, SIMPLE, LIQUID)
	, Oil_ExtraHeavy			("liquid_extra_heavy_oil"									, SIMPLE, LIQUID)
	, Oil_Light2				("lightoil"													, SIMPLE, LIQUID)
	, Oil_Heavy2				("heavyoil"													, SIMPLE, LIQUID)
	, Oil_HotCrude				("hotcrude"													, SIMPLE, LIQUID)
	
	, Kerosine					("kerosine"					, "kerosene"					, SIMPLE, LIQUID)
	
	, Glue						("glue"														, SIMPLE, LIQUID)
	, Latex						("latex"					, "molten.latex"				, SIMPLE, LIQUID)
	, Concrete					("concrete"					, "molten.concrete"				, SIMPLE, LIQUID)
	, Sewage					("sewage"													, SIMPLE, LIQUID)
	, Glass						("glass"					, "molten.glass"				, SIMPLE, LIQUID)
	, Sluice					("sluicejuice"												, SIMPLE, LIQUID)
	
	, Blaze						("blaze"					, "molten.blaze"				, LIQUID)
	
	, Potion_Awkward			("potion.awkward"											, SIMPLE, LIQUID, POTION)
	, Potion_Thick				("potion.thick"												, SIMPLE, LIQUID, POTION)
	, Potion_Mundane			("potion.mundane"											, SIMPLE, LIQUID, POTION)
	, Potion_Harm_1				("potion.damage"											, SIMPLE, LIQUID, POTION)
	, Potion_Harm_2				("potion.damage.strong"										, SIMPLE, LIQUID, POTION)
	, Potion_Harm_1S			("potion.damage.splash"										, SIMPLE, LIQUID, POTION)
	, Potion_Harm_2S			("potion.damage.strong.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Heal_1				("potion.health"											, SIMPLE, LIQUID, POTION)
	, Potion_Heal_2				("potion.health.strong"										, SIMPLE, LIQUID, POTION)
	, Potion_Heal_1S			("potion.health.splash"										, SIMPLE, LIQUID, POTION)
	, Potion_Heal_2S			("potion.health.strong.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Speed_1			("potion.speed"												, SIMPLE, LIQUID, POTION)
	, Potion_Speed_2			("potion.speed.strong"										, SIMPLE, LIQUID, POTION)
	, Potion_Speed_1L			("potion.speed.long"										, SIMPLE, LIQUID, POTION)
	, Potion_Speed_1S			("potion.speed.splash"										, SIMPLE, LIQUID, POTION)
	, Potion_Speed_2S			("potion.speed.strong.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Speed_1LS			("potion.speed.long.splash"									, SIMPLE, LIQUID, POTION)
	, Potion_Strength_1			("potion.strength"											, SIMPLE, LIQUID, POTION)
	, Potion_Strength_2			("potion.strength.strong"									, SIMPLE, LIQUID, POTION)
	, Potion_Strength_1L		("potion.strength.long"										, SIMPLE, LIQUID, POTION)
	, Potion_Strength_1S		("potion.strength.splash"									, SIMPLE, LIQUID, POTION)
	, Potion_Strength_2S		("potion.strength.strong.splash"							, SIMPLE, LIQUID, POTION)
	, Potion_Strength_1LS		("potion.strength.long.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Regen_1			("potion.regen"												, SIMPLE, LIQUID, POTION)
	, Potion_Regen_2			("potion.regen.strong"										, SIMPLE, LIQUID, POTION)
	, Potion_Regen_1L			("potion.regen.long"										, SIMPLE, LIQUID, POTION)
	, Potion_Regen_1S			("potion.regen.splash"										, SIMPLE, LIQUID, POTION)
	, Potion_Regen_2S			("potion.regen.strong.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Regen_1LS			("potion.regen.long.splash"									, SIMPLE, LIQUID, POTION)
	, Potion_Poison_1			("potion.poison"											, SIMPLE, LIQUID, POTION)
	, Potion_Poison_2			("potion.poison.strong"										, SIMPLE, LIQUID, POTION)
	, Potion_Poison_1L			("potion.poison.long"										, SIMPLE, LIQUID, POTION)
	, Potion_Poison_1S			("potion.poison.splash"										, SIMPLE, LIQUID, POTION)
	, Potion_Poison_2S			("potion.poison.strong.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Poison_1LS			("potion.poison.long.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_FireResistance_1	("potion.fireresistance"									, SIMPLE, LIQUID, POTION)
	, Potion_FireResistance_1L	("potion.fireresistance.long"								, SIMPLE, LIQUID, POTION)
	, Potion_FireResistance_1S	("potion.fireresistance.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_FireResistance_1LS	("potion.fireresistance.long.splash"						, SIMPLE, LIQUID, POTION)
	, Potion_NightVision_1		("potion.nightvision"										, SIMPLE, LIQUID, POTION)
	, Potion_NightVision_1L		("potion.nightvision.long"									, SIMPLE, LIQUID, POTION)
	, Potion_NightVision_1S		("potion.nightvision.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_NightVision_1LS	("potion.nightvision.long.splash"							, SIMPLE, LIQUID, POTION)
	, Potion_Weakness_1			("potion.weakness"											, SIMPLE, LIQUID, POTION)
	, Potion_Weakness_1L		("potion.weakness.long"										, SIMPLE, LIQUID, POTION)
	, Potion_Weakness_1S		("potion.weakness.splash"									, SIMPLE, LIQUID, POTION)
	, Potion_Weakness_1LS		("potion.weakness.long.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Slowness_1			("potion.slowness"											, SIMPLE, LIQUID, POTION)
	, Potion_Slowness_1L		("potion.slowness.long"										, SIMPLE, LIQUID, POTION)
	, Potion_Slowness_1S		("potion.slowness.splash"									, SIMPLE, LIQUID, POTION)
	, Potion_Slowness_1LS		("potion.slowness.long.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_WaterBreathing_1	("potion.waterbreathing"									, SIMPLE, LIQUID, POTION)
	, Potion_WaterBreathing_1L	("potion.waterbreathing.long"								, SIMPLE, LIQUID, POTION)
	, Potion_WaterBreathing_1S	("potion.waterbreathing.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_WaterBreathing_1LS	("potion.waterbreathing.long.splash"						, SIMPLE, LIQUID, POTION)
	, Potion_Invisibility_1		("potion.invisibility"										, SIMPLE, LIQUID, POTION)
	, Potion_Invisibility_1L	("potion.invisibility.long"									, SIMPLE, LIQUID, POTION)
	, Potion_Invisibility_1S	("potion.invisibility.splash"								, SIMPLE, LIQUID, POTION)
	, Potion_Invisibility_1LS	("potion.invisibility.long.splash"							, SIMPLE, LIQUID, POTION)
	;
	
	public final String mName;
	
	private FL(String aName, Collection<String>... aFluidSets) {
		mName = aName;
		for (Collection<String> aFluidSet : aFluidSets) {aFluidSet.add(mName);}
	}
	private FL(String aName, String aOldName, Collection<String>... aFluidSets) {
		mName = aName;
		FluidsGT.FLUID_RENAMINGS.put(aOldName, mName);
		for (Collection<String> aFluidSet : aFluidSets) {aFluidSet.add(mName); aFluidSet.add(aOldName);}
	}
	private FL(String aName, String aOldName1, String aOldName2, Collection<String>... aFluidSets) {
		mName = aName;
		FluidsGT.FLUID_RENAMINGS.put(aOldName1, mName);
		FluidsGT.FLUID_RENAMINGS.put(aOldName2, mName);
		for (Collection<String> aFluidSet : aFluidSets) {aFluidSet.add(mName); aFluidSet.add(aOldName1); aFluidSet.add(aOldName2);}
	}
	
	public int id() {return FluidRegistry.getFluidID(mName);}
	public Fluid fluid() {return FluidRegistry.getFluid(mName);}
	public boolean exists() {return FluidRegistry.getFluid(mName) != null;}
	
	public FluidStack make (long aAmount) {return UT.Fluids.make (mName, aAmount);}
	public FluidStack make_(long aAmount) {return UT.Fluids.make_(mName, aAmount);}
	public FluidStack make (long aAmount, String aReplacement) {return UT.Fluids.make (mName, aAmount, aReplacement);}
	public FluidStack make_(long aAmount, String aReplacement) {return UT.Fluids.make_(mName, aAmount, aReplacement);}
	public FluidStack make (long aAmount, FL aReplacement) {return UT.Fluids.make (mName, aAmount, aReplacement.mName);}
	public FluidStack make_(long aAmount, FL aReplacement) {return UT.Fluids.make_(mName, aAmount, aReplacement.mName);}
	public FluidStack make (long aAmount, String aReplacement, long aReplacementAmount) {return UT.Fluids.make (mName, aAmount, aReplacement, aReplacementAmount);}
	public FluidStack make_(long aAmount, String aReplacement, long aReplacementAmount) {return UT.Fluids.make_(mName, aAmount, aReplacement, aReplacementAmount);}
	public FluidStack make (long aAmount, FL aReplacement, long aReplacementAmount) {return UT.Fluids.make (mName, aAmount, aReplacement.mName, aReplacementAmount);}
	public FluidStack make_(long aAmount, FL aReplacement, long aReplacementAmount) {return UT.Fluids.make_(mName, aAmount, aReplacement.mName, aReplacementAmount);}
	
	public boolean is(IFluidTank aTank) {return is(aTank.getFluid());}
	public boolean is(FluidStack aFluid) {return aFluid != null && is(aFluid.getFluid());}
	public boolean is(Fluid aFluid) {return aFluid != null && aFluid.getName().equalsIgnoreCase(mName);}
	public boolean is(String aFluidName) {return aFluidName != null && aFluidName.equalsIgnoreCase(mName);}
	public boolean is(Collection<String> aFluidSet) {return aFluidSet.contains(mName);}
}